From e4ad1a5530e08ef3eae976a78a3589d52c9cad3b Mon Sep 17 00:00:00 2001
From: Egbert Eich <eich@suse.com>
Date: Sat, 14 May 2022 09:23:17 +0200
Subject: [PATCH 13/34] Add missing auth_info arguments

Signed-off-by: Egbert Eich <eich@suse.com>

# Conflicts:
#	src/common/slurm_protocol_api.c
---
 src/common/slurm_protocol_api.c | 23 ++++++++++++++++-------
 1 file changed, 16 insertions(+), 7 deletions(-)

diff --git a/src/common/slurm_protocol_api.c b/src/common/slurm_protocol_api.c
index c3ee239858..14e33bdeb7 100644
--- a/src/common/slurm_protocol_api.c
+++ b/src/common/slurm_protocol_api.c
@@ -869,7 +869,7 @@ char *slurm_get_priority_weight_tres(void)
 	return weights;
 }
 
-static int _check_hash(buf_t *buffer, header_t *header, slurm_msg_t *msg,
+static int _check_hash(struct slurm_buf *buffer, header_t *header, slurm_msg_t *msg,
 		       void *cred)
 {
 	char *cred_hash = NULL;
@@ -3158,6 +3158,7 @@ extern int slurm_unpack_received_msg(slurm_msg_t *msg, int fd, Buf buffer)
 	header_t header;
 	int rc;
 	void *auth_cred = NULL;
+	char *auth_info;
 	uint32_t body_offset = 0;
 
 	if (unpack_header(&header, buffer) == SLURM_ERROR) {
@@ -3208,7 +3209,7 @@ extern int slurm_unpack_received_msg(slurm_msg_t *msg, int fd, Buf buffer)
 	if (header.flags & SLURM_GLOBAL_AUTH_KEY) {
 		rc = g_slurm_auth_verify(auth_cred, _global_auth_key());
 	} else {
-		char *auth_info = slurm_get_auth_info();
+		auth_info = slurm_get_auth_info();
 		rc = g_slurm_auth_verify(auth_cred, auth_info);
 		xfree(auth_info);
 	}
@@ -3222,7 +3223,9 @@ extern int slurm_unpack_received_msg(slurm_msg_t *msg, int fd, Buf buffer)
 		goto total_return;
 	}
 
-	msg->auth_uid = g_slurm_auth_get_uid(auth_cred);
+	auth_info = slurm_get_auth_info();
+	msg->auth_uid = g_slurm_auth_get_uid(auth_cred, auth_info);
+	xfree(auth_info);
 	msg->auth_uid_set = true;
 
 	/*
@@ -3385,6 +3388,7 @@ List slurm_receive_msgs(int fd, int steps, int timeout)
 	ret_data_info_t *ret_data_info = NULL;
 	List ret_list = NULL;
 	int orig_timeout = timeout;
+	char *auth_info;
 
 	xassert(fd >= 0);
 
@@ -3490,7 +3494,7 @@ List slurm_receive_msgs(int fd, int steps, int timeout)
 	if (header.flags & SLURM_GLOBAL_AUTH_KEY) {
 		rc = g_slurm_auth_verify(auth_cred, _global_auth_key());
 	} else {
-		char *auth_info = slurm_get_auth_info();
+		auth_info = slurm_get_auth_info();
 		rc = g_slurm_auth_verify(auth_cred, auth_info);
 		xfree(auth_info);
 	}
@@ -3504,7 +3508,9 @@ List slurm_receive_msgs(int fd, int steps, int timeout)
 		goto total_return;
 	}
 
-	msg.auth_uid = g_slurm_auth_get_uid(auth_cred);
+	auth_info = slurm_get_auth_info();
+	msg.auth_uid = g_slurm_auth_get_uid(auth_cred, auth_info);
+	xfree(auth_info);
 	msg.auth_uid_set = true;
 	/*
 	 * Unpack message body
@@ -3743,6 +3749,7 @@ int slurm_receive_msg_and_forward(int fd, slurm_addr_t *orig_addr,
 	int rc;
 	void *auth_cred = NULL;
 	Buf buffer;
+	char *auth_info;
 
 	xassert(fd >= 0);
 
@@ -3878,7 +3885,7 @@ int slurm_receive_msg_and_forward(int fd, slurm_addr_t *orig_addr,
 	if (header.flags & SLURM_GLOBAL_AUTH_KEY) {
 		rc = g_slurm_auth_verify(auth_cred, _global_auth_key());
 	} else {
-		char *auth_info = slurm_get_auth_info();
+		auth_info = slurm_get_auth_info();
 		rc = g_slurm_auth_verify(auth_cred, auth_info);
 		xfree(auth_info);
 	}
@@ -3892,7 +3899,9 @@ int slurm_receive_msg_and_forward(int fd, slurm_addr_t *orig_addr,
 		goto total_return;
 	}
 
-	msg->auth_uid = g_slurm_auth_get_uid(auth_cred);
+	auth_info = slurm_get_auth_info();
+	msg->auth_uid = g_slurm_auth_get_uid(auth_cred, auth_info);
+	xfree(auth_info);
 	msg->auth_uid_set = true;
 
 	/*
-- 
2.35.3


